/*
 * Tests for Wyjec - expression language, version 1.0
 * (c) Copyright by Zbigniew Chyla 2005
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */
package pl.chyla.wyjec;

import junit.framework.Test;
import junit.framework.TestSuite;
import pl.chyla.wyjec.apphelpers.AllTestsAppHelpers;
import pl.chyla.wyjec.core.AllTestsCore;
import pl.chyla.wyjec.evaluator.AllTestsEvaluator;
import pl.chyla.wyjec.extfuncs.AllTestsExtFuncs;
import pl.chyla.wyjec.lexer.AllTestsLexer;
import pl.chyla.wyjec.parser.AllTestsParser;
import pl.chyla.wyjec.repo.AllTestsRepo;
import pl.chyla.wyjec.stdconsts.AllTestsStdConsts;
import pl.chyla.wyjec.stdfuncs.AllTestsStdFuncs;
import pl.chyla.wyjec.utils.AllTestsUtils;


/**
 * Tests for classes from "pl.chyla.wyjec" package and its sub-packages.
 *
 * @author Zbigniew Chyla (zbigniew@chyla.pl)
 */
public final class AllTestsWyjec {

    /**
     * Empty default constructor
     */
    private AllTestsWyjec() { }

    /**
     * Builds test suite with all Wyjec tests.
     *
     * @return test suite with all Wyjec tests
     */
    public static Test suite() {
        TestSuite suite = new TestSuite();
        suite.addTest(AllTestsAppHelpers.suite());
        suite.addTest(AllTestsCore.suite());
        suite.addTest(AllTestsEvaluator.suite());
        suite.addTest(AllTestsExtFuncs.suite());
        suite.addTest(AllTestsLexer.suite());
        suite.addTest(AllTestsParser.suite());
        suite.addTest(AllTestsRepo.suite());
        suite.addTest(AllTestsStdConsts.suite());
        suite.addTest(AllTestsStdFuncs.suite());
        suite.addTest(AllTestsUtils.suite());
        return suite;
    }

}
