/*
 * Tests for Wyjec - expression language, version 1.0
 * (c) Copyright by Zbigniew Chyla 2005
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */
package pl.chyla.wyjec.extfuncs.mathfuncs;

import junit.framework.Test;
import junit.framework.TestSuite;


/**
 * Tests for classes from "pl.chyla.wyjec.extfuncs.mathfuncs" package.
 *
 * @author Zbigniew Chyla (zbigniew@chyla.pl)
 */
public final class AllTestsMathFuncs extends TestSuite {

    /**
     * Builds test suite with all tests for functions implementing mathematical operations.
     *
     * @return test suite with tests for classes from "mathfuncs" package.
     */
    public static Test suite() {
        TestSuite suite = new TestSuite();
        suite.addTestSuite(TestFnCos.class);
        suite.addTestSuite(TestFnSin.class);
        suite.addTestSuite(TestFnTan.class);
        suite.addTestSuite(TestMathFunctions.class);
        return suite;
    }

}
