/*
 * Tests for Wyjec - expression language, version 1.0
 * (c) Copyright by Zbigniew Chyla 2005
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */
package pl.chyla.wyjec.stdfuncs.datefuncs.arithmetic;

import pl.chyla.wyjec.core.Value;
import pl.chyla.wyjec.core.functions.BaseTestDateFunction;


/**
 * Tests for {@link FnAdditionHours} class.
 *
 * @author Zbigniew Chyla (zbigniew@chyla.pl)
 */
public final class TestFnAdditionHours extends BaseTestDateFunction {

    /**
     * Constructs test instance with associated instance of the function.
     */
    public TestFnAdditionHours() {
        super(new FnAdditionHours());
    }

    /**
     * Tests implementation of the function.
     */
    public void testEvaluate() {
        checkFunctionResult(
            new Value[] {makeDateValue(1970, 1, 1, 12, 34, 56), makeIntegerValue(28)},
            makeDateValue(1970, 1, 2, 16, 34, 56).getDate());
        checkFunctionResult(
            new Value[] {makeDateValue(1977, 3, 9, 21, 0, 0), makeIntegerValue(0)},
            makeDateValue(1977, 3, 9, 21, 0, 0).getDate());
        checkFunctionResult(
            new Value[] {makeDateValue(1977, 3, 9, 21, 0, 0), makeIntegerValue(24 * 31)},
            makeDateValue(1977, 4, 9, 21, 0, 0).getDate());
        checkFunctionResult(
            new Value[] {makeDateValue(1977, 3, 9, 21, 0, 0), makeIntegerValue(-24 * 31)},
            makeDateValue(1977, 2, 6, 21, 0, 0).getDate());
        checkFunctionResult(
            new Value[] {makeDateValue(1978, 2, 28, 16, 17, 18), makeIntegerValue(20)},
            makeDateValue(1978, 3, 1, 12, 17, 18).getDate());
        checkFunctionResult(
            new Value[] {makeDateValue(2000, 2, 28, 16, 17, 18), makeIntegerValue(20)},
            makeDateValue(2000, 2, 29, 12, 17, 18).getDate());
    }

}
