/*
 * Tests for Wyjec - expression language, version 1.0
 * (c) Copyright by Zbigniew Chyla 2005
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */
package pl.chyla.wyjec.stdfuncs.datefuncs.arithmetic;

import pl.chyla.wyjec.core.Value;
import pl.chyla.wyjec.core.functions.BaseTestDateFunction;


/**
 * Tests for {@link FnAdditionMinutes} class.
 *
 * @author Zbigniew Chyla (zbigniew@chyla.pl)
 */
public final class TestFnAdditionMinutes extends BaseTestDateFunction {

    /**
     * Constructs test instance with associated instance of the function.
     */
    public TestFnAdditionMinutes() {
        super(new FnAdditionMinutes());
    }

    /**
     * Tests implementation of the function.
     */
    public void testEvaluate() {
        checkFunctionResult(
            new Value[] {makeDateValue(1970, 1, 1, 12, 34, 56), makeIntegerValue(40)},
            makeDateValue(1970, 1, 1, 13, 14, 56).getDate());
        checkFunctionResult(
            new Value[] {makeDateValue(1977, 3, 9, 21, 0, 0), makeIntegerValue(0)},
            makeDateValue(1977, 3, 9, 21, 0, 0).getDate());
        checkFunctionResult(
            new Value[] {makeDateValue(1977, 3, 9, 21, 0, 0), makeIntegerValue(241)},
            makeDateValue(1977, 3, 10, 1, 1, 0).getDate());
        checkFunctionResult(
            new Value[] {makeDateValue(1977, 3, 9, 21, 0, 0), makeIntegerValue(-241)},
            makeDateValue(1977, 3, 9, 16, 59, 0).getDate());
        checkFunctionResult(
            new Value[] {makeDateValue(1978, 2, 28, 23, 17, 18), makeIntegerValue(55)},
            makeDateValue(1978, 3, 1, 0, 12, 18).getDate());
        checkFunctionResult(
            new Value[] {makeDateValue(2000, 2, 28, 23, 17, 18), makeIntegerValue(55)},
            makeDateValue(2000, 2, 29, 0, 12, 18).getDate());
    }

}
