/*
 * Tests for Wyjec - expression language, version 1.0
 * (c) Copyright by Zbigniew Chyla 2005
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */
package pl.chyla.wyjec.stdfuncs.datefuncs.arithmetic;

import pl.chyla.wyjec.core.Value;
import pl.chyla.wyjec.core.functions.BaseTestIntegerFunction;


/**
 * Tests for {@link FnSubtractionHours} class.
 *
 * @author Zbigniew Chyla (zbigniew@chyla.pl)
 */
public final class TestFnSubtractionHours extends BaseTestIntegerFunction {

    /**
     * Constructs test instance with associated instance of the function.
     */
    public TestFnSubtractionHours() {
        super(new FnSubtractionHours());
    }

    /**
     * Tests implementation of the function.
     */
    public void testEvaluate() {
        checkFunctionResult(
            new Value[] {
                makeDateValue(1970, 1, 1, 13, 34, 56), makeDateValue(1970, 1, 1, 13, 12, 34)},
            0L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1970, 1, 1, 13, 34, 56), makeDateValue(1970, 1, 1, 12, 56, 56)},
            0L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1970, 1, 1, 13, 34, 56), makeDateValue(1970, 1, 1, 12, 0, 0)},
            1L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1977, 3, 9, 21, 0, 0), makeDateValue(1977, 3, 8, 15, 0, 0)},
            30L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1977, 3, 8, 15, 0, 0), makeDateValue(1977, 3, 9, 21, 0, 0)},
            -30L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1977, 3, 9, 21, 15, 0), makeDateValue(1977, 3, 8, 15, 45, 0)},
            29L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1977, 3, 8, 15, 45, 0), makeDateValue(1977, 3, 9, 21, 15, 0)},
            -29L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1978, 3, 1, 7, 0, 0), makeDateValue(1978, 2, 27, 18, 0, 0)},
            37L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(2000, 3, 1, 7, 0, 0), makeDateValue(2000, 2, 27, 18, 0, 0)},
            61L);
    }

}
