/*
 * Tests for Wyjec - expression language, version 1.0
 * (c) Copyright by Zbigniew Chyla 2005
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */
package pl.chyla.wyjec.stdfuncs.datefuncs.arithmetic;

import pl.chyla.wyjec.core.Value;
import pl.chyla.wyjec.core.functions.BaseTestIntegerFunction;


/**
 * Tests for {@link FnSubtractionMinutes} class.
 *
 * @author Zbigniew Chyla (zbigniew@chyla.pl)
 */
public final class TestFnSubtractionMinutes extends BaseTestIntegerFunction {

    /**
     * Constructs test instance with associated instance of the function.
     */
    public TestFnSubtractionMinutes() {
        super(new FnSubtractionMinutes());
    }

    /**
     * Tests implementation of the function.
     */
    public void testEvaluate() {
        checkFunctionResult(
            new Value[] {
                makeDateValue(1970, 1, 1, 20, 30, 55), makeDateValue(1970, 1, 1, 20, 30, 15)},
            0L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1970, 1, 1, 20, 31, 10), makeDateValue(1970, 1, 1, 20, 30, 15)},
            0L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1970, 1, 1, 20, 31, 10), makeDateValue(1970, 1, 1, 20, 30, 0)},
            1L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1977, 3, 9, 21, 55, 0), makeDateValue(1977, 3, 9, 21, 5, 0)},
            50L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1977, 3, 9, 21, 5, 0), makeDateValue(1977, 3, 9, 21, 55, 0)},
            -50L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1977, 3, 9, 21, 55, 0), makeDateValue(1977, 3, 9, 21, 5, 20)},
            49L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1977, 3, 9, 21, 5, 20), makeDateValue(1977, 3, 9, 21, 55, 0)},
            -49L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1978, 3, 1, 0, 15, 0), makeDateValue(1978, 2, 28, 23, 30, 0)},
            45L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(2000, 3, 1, 0, 15, 0), makeDateValue(2000, 2, 28, 23, 30, 0)},
            1485L);
    }

}
