/*
 * Tests for Wyjec - expression language, version 1.0
 * (c) Copyright by Zbigniew Chyla 2005
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */
package pl.chyla.wyjec.stdfuncs.datefuncs.arithmetic;

import pl.chyla.wyjec.core.Value;
import pl.chyla.wyjec.core.functions.BaseTestIntegerFunction;


/**
 * Tests for {@link FnSubtractionSeconds} class.
 *
 * @author Zbigniew Chyla (zbigniew@chyla.pl)
 */
public final class TestFnSubtractionSeconds extends BaseTestIntegerFunction {

    /**
     * Constructs test instance with associated instance of the function.
     */
    public TestFnSubtractionSeconds() {
        super(new FnSubtractionSeconds());
    }

    /**
     * Tests implementation of the function.
     */
    public void testEvaluate() {
        checkFunctionResult(
            new Value[] {
                makeDateValue(1970, 1, 1, 13, 34, 56), makeDateValue(1970, 1, 1, 13, 34, 56)},
            0L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1970, 1, 1, 13, 34, 59), makeDateValue(1970, 1, 1, 13, 34, 56)},
            3L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1970, 1, 1, 13, 35, 15), makeDateValue(1970, 1, 1, 13, 34, 56)},
            19L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1977, 3, 9, 21, 0, 30), makeDateValue(1977, 3, 9, 21, 0, 5)},
            25L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1977, 3, 9, 21, 0, 5), makeDateValue(1977, 3, 9, 21, 0, 30)},
            -25L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(1978, 3, 1, 0, 0, 15), makeDateValue(1978, 2, 28, 23, 59, 45)},
            30L);
        checkFunctionResult(
            new Value[] {
                makeDateValue(2000, 3, 1, 0, 0, 15), makeDateValue(2000, 2, 28, 23, 59, 45)},
            86430L);
    }

}
