/*
 * Tests for Wyjec - expression language, version 1.0
 * (c) Copyright by Zbigniew Chyla 2005
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */
package pl.chyla.wyjec.stdfuncs.datefuncs.selection;

import pl.chyla.wyjec.core.Value;
import pl.chyla.wyjec.core.functions.BaseTestDateFunction;


/**
 * Tests for {@link FnIf} class.
 *
 * @author Zbigniew Chyla (zbigniew@chyla.pl)
 */
public final class TestFnIf extends BaseTestDateFunction {

    /**
     * Constructs test instance with associated instance of the function.
     */
    public TestFnIf() {
        super(new FnIf());
    }

    /**
     * Tests implementation of the function.
     */
    public void testEvaluate() {
        Value aDate = makeDateValue(1977, 3, 9, 21, 0, 0);
        Value bDate = makeDateValue(1978, 9, 11, 15, 0, 0);
        checkFunctionResult(
            new Value[] {makeBooleanValue(true), aDate, bDate},
            aDate.getDate());
        checkFunctionResult(
            new Value[] {makeBooleanValue(false), aDate, bDate},
            bDate.getDate());
    }

}
