/*
 * Tests for Wyjec - expression language, version 1.0
 * (c) Copyright by Zbigniew Chyla 2005
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */
package pl.chyla.wyjec.stdfuncs.floatfuncs;

import junit.framework.Test;
import junit.framework.TestSuite;
import pl.chyla.wyjec.stdfuncs.floatfuncs.arithmetic.TestFnAbs;
import pl.chyla.wyjec.stdfuncs.floatfuncs.arithmetic.TestFnAddition;
import pl.chyla.wyjec.stdfuncs.floatfuncs.arithmetic.TestFnCeil;
import pl.chyla.wyjec.stdfuncs.floatfuncs.arithmetic.TestFnDivision;
import pl.chyla.wyjec.stdfuncs.floatfuncs.arithmetic.TestFnFloor;
import pl.chyla.wyjec.stdfuncs.floatfuncs.arithmetic.TestFnModulo;
import pl.chyla.wyjec.stdfuncs.floatfuncs.arithmetic.TestFnMultiplication;
import pl.chyla.wyjec.stdfuncs.floatfuncs.arithmetic.TestFnNegation;
import pl.chyla.wyjec.stdfuncs.floatfuncs.arithmetic.TestFnSubtraction;
import pl.chyla.wyjec.stdfuncs.floatfuncs.basic.TestFnFloat;
import pl.chyla.wyjec.stdfuncs.floatfuncs.basic.TestFnStr;
import pl.chyla.wyjec.stdfuncs.floatfuncs.relations.TestFnEqual;
import pl.chyla.wyjec.stdfuncs.floatfuncs.relations.TestFnGreater;
import pl.chyla.wyjec.stdfuncs.floatfuncs.relations.TestFnGreaterOrEqual;
import pl.chyla.wyjec.stdfuncs.floatfuncs.relations.TestFnLess;
import pl.chyla.wyjec.stdfuncs.floatfuncs.relations.TestFnLessOrEqual;
import pl.chyla.wyjec.stdfuncs.floatfuncs.selection.TestFnIf;
import pl.chyla.wyjec.stdfuncs.floatfuncs.selection.TestFnMax;
import pl.chyla.wyjec.stdfuncs.floatfuncs.selection.TestFnMin;
import pl.chyla.wyjec.stdfuncs.floatfuncs.selection.TestFnSelect;


/**
 * Tests for classes from "pl.chyla.wyjec.stdfuncs.floatfuncs" package and its sub-packages.
 *
 * @author Zbigniew Chyla (zbigniew@chyla.pl)
 */
public final class AllTestsFloatFuncs extends TestSuite {

    /**
     * Builds test suite with all tests for standard Wyjec float functions.
     *
     * @return test suite with tests for classes from "floatfuncs" package and its sub-packages.
     */
    public static Test suite() {
        TestSuite suite = new TestSuite();
        suite.addTestSuite(TestFloatFunctions.class);
        suite.addTestSuite(TestFnAbs.class);
        suite.addTestSuite(TestFnAddition.class);
        suite.addTestSuite(TestFnCeil.class);
        suite.addTestSuite(TestFnDivision.class);
        suite.addTestSuite(TestFnFloor.class);
        suite.addTestSuite(TestFnModulo.class);
        suite.addTestSuite(TestFnMultiplication.class);
        suite.addTestSuite(TestFnNegation.class);
        suite.addTestSuite(TestFnSubtraction.class);
        suite.addTestSuite(TestFnFloat.class);
        suite.addTestSuite(TestFnStr.class);
        suite.addTestSuite(TestFnEqual.class);
        suite.addTestSuite(TestFnGreater.class);
        suite.addTestSuite(TestFnGreaterOrEqual.class);
        suite.addTestSuite(TestFnLess.class);
        suite.addTestSuite(TestFnLessOrEqual.class);
        suite.addTestSuite(TestFnIf.class);
        suite.addTestSuite(TestFnMax.class);
        suite.addTestSuite(TestFnMin.class);
        suite.addTestSuite(TestFnSelect.class);
        return suite;
    }

}
