/*
 * Tests for Wyjec - expression language, version 1.0
 * (c) Copyright by Zbigniew Chyla 2005
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */
package pl.chyla.wyjec.stdfuncs.integerfuncs.arithmetic;

import pl.chyla.wyjec.core.Value;
import pl.chyla.wyjec.core.functions.BaseTestIntegerFunction;


/**
 * Tests for {@link FnDivisionWithDefault} class.
 *
 * @author Zbigniew Chyla (zbigniew@chyla.pl)
 */
public final class TestFnDivisionWithDefault extends BaseTestIntegerFunction {

    /**
     * Constructs test instance with associated instance of the function.
     */
    public TestFnDivisionWithDefault() {
        super(new FnDivisionWithDefault());
    }

    /**
     * Tests implementation of the function.
     */
    public void testEvaluate() {
        checkFunctionResult(
            new Value[] {makeIntegerValue(3L), makeIntegerValue(5L), makeIntegerValue(10L)},
            0L);
        checkFunctionResult(
            new Value[] {makeIntegerValue(0L), makeIntegerValue(5L), makeIntegerValue(10L)},
            0L);
        checkFunctionResult(
            new Value[] {makeIntegerValue(-5L), makeIntegerValue(0L), makeIntegerValue(10L)},
            10L);
        checkFunctionResult(
            new Value[] {makeIntegerValue(29L), makeIntegerValue(5L), makeIntegerValue(10L)},
            5L);
        checkFunctionResult(
            new Value[] {makeIntegerValue(-29L), makeIntegerValue(5L), makeIntegerValue(10L)},
            -5L);
        checkFunctionResult(
            new Value[] {
                makeIntegerValue(123456789L * 123456L), makeIntegerValue(123456L),
                makeIntegerValue(10L)},
            123456789L);
        checkFunctionResult(
            new Value[] {
                makeIntegerValue(-123456789L * 123456L), makeIntegerValue(-123456L),
                makeIntegerValue(10L)},
            123456789L);
        checkFunctionResult(
            new Value[] {makeIntegerValue(0L), makeIntegerValue(0L), makeIntegerValue(10L)},
            10L);
        checkFunctionResult(
            new Value[] {
                makeIntegerValue(-9223372036854775808L), makeIntegerValue(-1L),
                makeIntegerValue(10L)},
            -9223372036854775808L);
    }

}
