/*
 * Tests for Wyjec - expression language, version 1.0
 * (c) Copyright by Zbigniew Chyla 2005
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */
package pl.chyla.wyjec.stdfuncs.stringfuncs.selection;

import pl.chyla.wyjec.core.Value;
import pl.chyla.wyjec.core.functions.BaseTestStringFunction;


/**
 * Tests for {@link FnIf} class.
 *
 * @author Zbigniew Chyla (zbigniew@chyla.pl)
 */
public final class TestFnIf extends BaseTestStringFunction {

    /**
     * Constructs test instance with associated instance of the function.
     */
    public TestFnIf() {
        super(new FnIf());
    }

    /**
     * Tests implementation of the function.
     */
    public void testEvaluate() {
        String aValue = "abcdefghij";
        String bValue = "XY";
        Value[] aValueVariants = makeStringValueVariants(aValue);
        Value[] bValueVariants = makeStringValueVariants(bValue);
        for (int ai = 0; ai < aValueVariants.length; ai++) {
            for (int bi = 0; bi < bValueVariants.length; bi++) {
                checkFunctionResultVarSizes(
                    new Value[] {
                        makeBooleanValue(true), aValueVariants[ai], bValueVariants[bi]},
                    aValue);
                checkFunctionResultVarSizes(
                    new Value[] {
                        makeBooleanValue(false), aValueVariants[ai], bValueVariants[bi]},
                    bValue);
            }
        }
    }

}
