/*
 * Tests for Wyjec - expression language, version 1.0
 * (c) Copyright by Zbigniew Chyla 2005
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */
package pl.chyla.wyjec.utils;

import junit.framework.TestCase;


/**
 * Tests for {@link CharUtils} class.
 *
 * @author Zbigniew Chyla (zbigniew@chyla.pl)
 */
public final class TestCharUtils extends TestCase {

    /**
     * Empty default constructor
     */
    public TestCharUtils() { }

    /**
     * Test for {@link CharUtils#isDigit(char)} method.
     */
    public void testIsDigit() {
        for (int i = Character.MIN_VALUE; i < Character.MAX_VALUE; i++) {
            boolean isDigit = i >= '0' && i <= '9';
            assertEquals(CharUtils.isDigit((char) i), isDigit);
        }
    }

}
